#!/usr/bin/python
""" Automatically generated by xacc on Fri Sep 12 09:13:52 2014 """
from ppci.pyyacc import LRParser, Reduce, Shift, Accept, Production, Grammar
from ppci import Token

from ..basetarget import Register, Instruction, Target, Label, Alignment
from .instructions import Add2, Sub, Sub3, Add3, Cmp, Lsl, Lsr, Orr, Add, Cmp2, Sub2, Mul, And
from .instructions import Dcd, Pop, Push, Yield, Mov2, Mov3
from .instructions import B, Bl, Bne, Beq, Blt, Bgt, Ble, Bge
from .instructions import Ldr, Str2, Ldr2, Str1, Ldr1, Ldr3, Adr
from .frame import ArmFrame
from .arminstructionselector import ArmInstructionSelector
from ..arm.registers import R0, R1, R2, R3, R4, R5, R6, R7, SP, LR, PC
from ..arm.registers import register_range
from ...assembler import BaseAssembler

class Parser(LRParser):
    def __init__(self):
        self.start_symbol = "asmline"
        self.grammar = Grammar({'nop', 'r6', 'sp', 'push', 'COMMENT', 'mov', 'lr', ']', 'ldr', '-', ':', 'r12', 'r11', 'r8', 'r5', 'blt', 'add', 'val8', 'lsl', 'r0', 'pop', 'dcd', 'cmp', ',', 'align', '=', '[', 'val5', 'orr', 'bgt', 'b', 'val12', 'r1', 'and', 'bl', 'ble', 'r9', 'val3', 'mul', 'beq', 'r10', 'pc', 'bge', 'r2', 'r4', 'adr', 'val16', 'r3', 'lsr', 'section', 'yield', '{', 'str', 'r7', 'val32', 'ID', 'sub', 'bne', '}'})
        self.grammar.add_production("asmline", ['asmline2'], self.action_asmline_0)
        self.grammar.add_production("asmline", ['asmline2', 'COMMENT'], self.action_asmline_1)
        self.grammar.add_production("asmline2", ['label', 'instr'], self.action_asmline2_2)
        self.grammar.add_production("asmline2", ['label'], self.action_asmline2_3)
        self.grammar.add_production("asmline2", ['instr'], self.action_asmline2_4)
        self.grammar.add_production("asmline2", [], self.action_asmline2_5)
        self.grammar.add_production("label", ['ID', ':'], self.action_label_6)
        self.grammar.add_production("instr", ['pseudoinstruction'], self.action_instr_7)
        self.grammar.add_production("instr", ['instruction'], self.action_instr_8)
        self.grammar.add_production("pseudoinstruction", ['nop'], self.action_pseudoinstruction_9)
        self.grammar.add_production("pseudoinstruction", ['section', 'ID'], self.action_pseudoinstruction_10)
        self.grammar.add_production("imm32", ['val32'], self.action_imm32_11)
        self.grammar.add_production("imm32", ['imm16'], self.action_imm32_12)
        self.grammar.add_production("imm16", ['val16'], self.action_imm16_13)
        self.grammar.add_production("imm16", ['imm12'], self.action_imm16_14)
        self.grammar.add_production("imm12", ['val12'], self.action_imm12_15)
        self.grammar.add_production("imm12", ['imm8'], self.action_imm12_16)
        self.grammar.add_production("imm8", ['val8'], self.action_imm8_17)
        self.grammar.add_production("imm8", ['imm5'], self.action_imm8_18)
        self.grammar.add_production("imm5", ['val5'], self.action_imm5_19)
        self.grammar.add_production("imm5", ['imm3'], self.action_imm5_20)
        self.grammar.add_production("imm3", ['val3'], self.action_imm3_21)
        self.grammar.add_production("reg8", ['r0'], self.action_reg8_22)
        self.grammar.add_production("reg8", ['r1'], self.action_reg8_23)
        self.grammar.add_production("reg8", ['r2'], self.action_reg8_24)
        self.grammar.add_production("reg8", ['r3'], self.action_reg8_25)
        self.grammar.add_production("reg8", ['r4'], self.action_reg8_26)
        self.grammar.add_production("reg8", ['r5'], self.action_reg8_27)
        self.grammar.add_production("reg8", ['r6'], self.action_reg8_28)
        self.grammar.add_production("reg8", ['r7'], self.action_reg8_29)
        self.grammar.add_production("instruction", ['dcd', 'imm32'], self.action_instruction_30)
        self.grammar.add_production("instruction", ['mov', 'reg8', ',', 'reg8'], self.action_instruction_31)
        self.grammar.add_production("instruction", ['mov', 'reg8', ',', 'imm8'], self.action_instruction_32)
        self.grammar.add_production("instruction", ['cmp', 'reg8', ',', 'reg8'], self.action_instruction_33)
        self.grammar.add_production("instruction", ['cmp', 'reg8', ',', 'imm8'], self.action_instruction_34)
        self.grammar.add_production("instruction", ['add', 'reg8', ',', 'reg8', ',', 'reg8'], self.action_instruction_35)
        self.grammar.add_production("instruction", ['add', 'reg8', ',', 'reg8', ',', 'imm3'], self.action_instruction_36)
        self.grammar.add_production("instruction", ['add', 'sp', ',', 'sp', ',', 'imm8'], self.action_instruction_37)
        self.grammar.add_production("instruction", ['sub', 'sp', ',', 'sp', ',', 'imm8'], self.action_instruction_38)
        self.grammar.add_production("instruction", ['sub', 'reg8', ',', 'reg8', ',', 'imm3'], self.action_instruction_39)
        self.grammar.add_production("instruction", ['lsl', 'reg8', ',', 'reg8'], self.action_instruction_40)
        self.grammar.add_production("instruction", ['lsr', 'reg8', ',', 'reg8'], self.action_instruction_41)
        self.grammar.add_production("instruction", ['and', 'reg8', ',', 'reg8'], self.action_instruction_42)
        self.grammar.add_production("instruction", ['orr', 'reg8', ',', 'reg8'], self.action_instruction_43)
        self.grammar.add_production("instruction", ['b', 'ID'], self.action_instruction_44)
        self.grammar.add_production("instruction", ['bl', 'ID'], self.action_instruction_45)
        self.grammar.add_production("instruction", ['beq', 'ID'], self.action_instruction_46)
        self.grammar.add_production("instruction", ['bne', 'ID'], self.action_instruction_47)
        self.grammar.add_production("instruction", ['blt', 'ID'], self.action_instruction_48)
        self.grammar.add_production("instruction", ['ble', 'ID'], self.action_instruction_49)
        self.grammar.add_production("instruction", ['bgt', 'ID'], self.action_instruction_50)
        self.grammar.add_production("instruction", ['bge', 'ID'], self.action_instruction_51)
        self.grammar.add_production("instruction", ['push', 'reg_list'], self.action_instruction_52)
        self.grammar.add_production("instruction", ['pop', 'reg_list'], self.action_instruction_53)
        self.grammar.add_production("reg_list", ['{', 'reg_list_inner', '}'], self.action_reg_list_54)
        self.grammar.add_production("reg_list_inner", ['reg_or_range'], self.action_reg_list_inner_55)
        self.grammar.add_production("reg_list_inner", ['reg_or_range', ',', 'reg_list_inner'], self.action_reg_list_inner_56)
        self.grammar.add_production("reg_or_range", ['reg8'], self.action_reg_or_range_57)
        self.grammar.add_production("reg_or_range", ['lr'], self.action_reg_or_range_58)
        self.grammar.add_production("reg_or_range", ['pc'], self.action_reg_or_range_59)
        self.grammar.add_production("reg_or_range", ['reg8', '-', 'reg8'], self.action_reg_or_range_60)
        self.grammar.add_production("instruction", ['str', 'reg8', ',', '[', 'reg8', ',', 'imm5', ']'], self.action_instruction_61)
        self.grammar.add_production("instruction", ['ldr', 'reg8', ',', '[', 'reg8', ',', 'imm5', ']'], self.action_instruction_62)
        self.grammar.add_production("instruction", ['ldr', 'reg8', ',', 'ID'], self.action_instruction_63)
        self.grammar.add_production("instruction", ['str', 'reg8', ',', '[', 'sp', ',', 'imm8', ']'], self.action_instruction_64)
        self.grammar.add_production("instruction", ['ldr', 'reg8', ',', '[', 'sp', ',', 'imm8', ']'], self.action_instruction_65)
        self.grammar.add_production("instruction", ['align', 'imm8'], self.action_instruction_66)
        self.grammar.add_production("instruction", ['adr', 'reg8', ',', 'ID'], self.action_instruction_67)
        self.grammar.add_production("instruction", ['yield'], self.action_instruction_68)
        self.action_table = {}
        self.action_table[(80, 'str')] = Reduce(6)
        self.action_table[(55, 'COMMENT')] = Reduce(44)
        self.action_table[(9, 'r1')] = Shift(40)
        self.action_table[(110, 'r7')] = Shift(144)
        self.action_table[(145, 'val8')] = Shift(49)
        self.action_table[(90, '}')] = Reduce(23)
        self.action_table[(55, 'EOF')] = Reduce(44)
        self.action_table[(14, 'r3')] = Shift(42)
        self.action_table[(85, '}')] = Reduce(55)
        self.action_table[(16, 'r2')] = Shift(41)
        self.action_table[(21, 'r1')] = Shift(40)
        self.action_table[(87, '}')] = Reduce(58)
        self.action_table[(98, 'r4')] = Shift(37)
        self.action_table[(97, 'sp')] = Shift(122)
        self.action_table[(102, 'r1')] = Shift(117)
        self.action_table[(124, 'r3')] = Shift(42)
        self.action_table[(5, 'blt')] = Shift(3)
        self.action_table[(26, 'r6')] = Shift(35)
        self.action_table[(160, 'val5')] = Shift(164)
        self.action_table[(0, 'bl')] = Shift(22)
        self.action_table[(104, 'r0')] = Shift(116)
        self.action_table[(120, 'EOF')] = Reduce(29)
        self.action_table[(5, 'push')] = Shift(1)
        self.action_table[(11, 'COMMENT')] = Reduce(68)
        self.action_table[(9, 'r4')] = Shift(37)
        self.action_table[(2, 'r2')] = Shift(41)
        self.action_table[(3, 'ID')] = Shift(44)
        self.action_table[(172, 'COMMENT')] = Reduce(62)
        self.action_table[(147, ',')] = Shift(155)
        self.action_table[(94, '-')] = Reduce(29)
        self.action_table[(12, 'r1')] = Shift(40)
        self.action_table[(95, 'val5')] = Shift(50)
        self.action_table[(153, 'COMMENT')] = Reduce(38)
        self.action_table[(73, 'COMMENT')] = Reduce(49)
        self.action_table[(0, 'adr')] = Shift(26)
        self.action_table[(0, 'bge')] = Shift(25)
        self.action_table[(114, 'COMMENT')] = Reduce(31)
        self.action_table[(124, 'r5')] = Shift(36)
        self.action_table[(134, 'sp')] = Shift(151)
        self.action_table[(96, 'r5')] = Shift(112)
        self.action_table[(8, 'val3')] = Shift(53)
        self.action_table[(80, 'mov')] = Reduce(6)
        self.action_table[(103, 'r5')] = Shift(112)
        self.action_table[(0, 'pop')] = Shift(7)
        self.action_table[(124, 'r0')] = Shift(39)
        self.action_table[(0, 'section')] = Shift(28)
        self.action_table[(128, 'COMMENT')] = Reduce(40)
        self.action_table[(108, 'EOF')] = Reduce(54)
        self.action_table[(126, ',')] = Shift(149)
        self.action_table[(66, 'COMMENT')] = Reduce(16)
        self.action_table[(14, 'r6')] = Shift(35)
        self.action_table[(160, 'val8')] = Shift(163)
        self.action_table[(27, 'r0')] = Shift(39)
        self.action_table[(12, 'r0')] = Shift(39)
        self.action_table[(131, 'COMMENT')] = Reduce(42)
        self.action_table[(103, 'r1')] = Shift(117)
        self.action_table[(0, 'bgt')] = Shift(19)
        self.action_table[(17, 'val32')] = Shift(68)
        self.action_table[(98, 'r7')] = Shift(43)
        self.action_table[(92, '}')] = Reduce(24)
        self.action_table[(0, 'dcd')] = Shift(17)
        self.action_table[(149, 'val5')] = Shift(50)
        self.action_table[(117, 'EOF')] = Reduce(23)
        self.action_table[(150, 'r7')] = Shift(120)
        self.action_table[(102, 'r6')] = Shift(111)
        self.action_table[(0, 'and')] = Shift(21)
        self.action_table[(110, 'r0')] = Shift(140)
        self.action_table[(16, 'r7')] = Shift(43)
        self.action_table[(0, 'ble')] = Shift(23)
        self.action_table[(117, 'COMMENT')] = Reduce(23)
        self.action_table[(103, 'r0')] = Shift(116)
        self.action_table[(18, 'r4')] = Shift(37)
        self.action_table[(26, 'r0')] = Shift(39)
        self.action_table[(26, 'r2')] = Shift(41)
        self.action_table[(17, 'val8')] = Shift(49)
        self.action_table[(103, 'val3')] = Shift(53)
        self.action_table[(21, 'r6')] = Shift(35)
        self.action_table[(113, 'EOF')] = Reduce(26)
        self.action_table[(75, 'EOF')] = Reduce(51)
        self.action_table[(18, 'r3')] = Shift(42)
        self.action_table[(104, 'r7')] = Shift(120)
        self.action_table[(134, 'r6')] = Shift(35)
        self.action_table[(13, 'COMMENT')] = Reduce(9)
        self.action_table[(162, ']')] = Reduce(20)
        self.action_table[(112, 'COMMENT')] = Reduce(27)
        self.action_table[(1, '{')] = Shift(34)
        self.action_table[(22, 'ID')] = Shift(72)
        self.action_table[(101, 'r4')] = Shift(37)
        self.action_table[(12, 'r6')] = Shift(35)
        self.action_table[(124, 'r1')] = Shift(40)
        self.action_table[(34, 'r7')] = Shift(94)
        self.action_table[(29, 'r7')] = Shift(43)
        self.action_table[(106, 'r3')] = Shift(119)
        self.action_table[(161, 'val3')] = Shift(167)
        self.action_table[(101, 'r3')] = Shift(42)
        self.action_table[(155, 'val3')] = Shift(167)
        self.action_table[(53, 'EOF')] = Reduce(21)
        self.action_table[(0, 'lsr')] = Shift(27)
        self.action_table[(44, 'COMMENT')] = Reduce(48)
        self.action_table[(5, 'sub')] = Shift(12)
        self.action_table[(158, 'COMMENT')] = Reduce(36)
        self.action_table[(2, 'r6')] = Shift(35)
        self.action_table[(155, 'val8')] = Shift(163)
        self.action_table[(95, 'r4')] = Shift(113)
        self.action_table[(47, 'COMMENT')] = Reduce(53)
        self.action_table[(139, ',')] = Reduce(60)
        self.action_table[(103, 'r3')] = Shift(119)
        self.action_table[(81, 'COMMENT')] = Reduce(47)
        self.action_table[(68, 'EOF')] = Reduce(11)
        self.action_table[(96, 'r0')] = Shift(116)
        self.action_table[(63, 'EOF')] = Reduce(13)
        self.action_table[(18, 'r0')] = Shift(39)
        self.action_table[(93, '}')] = Reduce(25)
        self.action_table[(77, ',')] = Shift(106)
        self.action_table[(95, 'r1')] = Shift(117)
        self.action_table[(16, 'r4')] = Shift(37)
        self.action_table[(84, '}')] = Shift(108)
        self.action_table[(130, 'EOF')] = Reduce(34)
        self.action_table[(98, 'r2')] = Shift(41)
        self.action_table[(11, 'EOF')] = Reduce(68)
        self.action_table[(0, 'str')] = Shift(29)
        self.action_table[(0, 'COMMENT')] = Reduce(5)
        self.action_table[(96, 'r1')] = Shift(117)
        self.action_table[(4, 'COMMENT')] = Shift(45)
        self.action_table[(2, 'r5')] = Shift(36)
        self.action_table[(150, 'r2')] = Shift(118)
        self.action_table[(99, 'ID')] = Shift(125)
        self.action_table[(79, ',')] = Shift(107)
        self.action_table[(136, ',')] = Reduce(28)
        self.action_table[(101, 'r0')] = Shift(39)
        self.action_table[(80, 'ldr')] = Reduce(6)
        self.action_table[(101, 'r1')] = Shift(40)
        self.action_table[(95, 'r0')] = Shift(116)
        self.action_table[(39, ',')] = Reduce(22)
        self.action_table[(99, '[')] = Shift(124)
        self.action_table[(5, 'yield')] = Shift(11)
        self.action_table[(9, 'r6')] = Shift(35)
        self.action_table[(115, 'EOF')] = Reduce(32)
        self.action_table[(149, 'val8')] = Shift(49)
        self.action_table[(134, 'r0')] = Shift(39)
        self.action_table[(65, 'COMMENT')] = Reduce(30)
        self.action_table[(12, 'sp')] = Shift(56)
        self.action_table[(102, 'r5')] = Shift(112)
        self.action_table[(91, ',')] = Reduce(59)
        self.action_table[(98, 'r0')] = Shift(39)
        self.action_table[(91, '}')] = Reduce(59)
        self.action_table[(4, 'EOF')] = Accept(0)
        self.action_table[(132, 'EOF')] = Reduce(67)
        self.action_table[(146, 'val3')] = Shift(53)
        self.action_table[(80, 'cmp')] = Reduce(6)
        self.action_table[(5, 'mov')] = Shift(2)
        self.action_table[(156, 'val5')] = Shift(164)
        self.action_table[(100, 'sp')] = Shift(126)
        self.action_table[(56, ',')] = Shift(97)
        self.action_table[(116, 'EOF')] = Reduce(22)
        self.action_table[(29, 'r2')] = Shift(41)
        self.action_table[(27, 'r6')] = Shift(35)
        self.action_table[(111, 'EOF')] = Reduce(28)
        self.action_table[(136, '}')] = Reduce(28)
        self.action_table[(152, ',')] = Shift(161)
        self.action_table[(172, 'EOF')] = Reduce(62)
        self.action_table[(14, 'r4')] = Shift(37)
        self.action_table[(171, 'EOF')] = Reduce(65)
        self.action_table[(80, 'pop')] = Reduce(6)
        self.action_table[(143, ',')] = Reduce(25)
        self.action_table[(80, 'ble')] = Reduce(6)
        self.action_table[(9, 'r3')] = Shift(42)
        self.action_table[(102, 'r7')] = Shift(120)
        self.action_table[(80, 'section')] = Reduce(6)
        self.action_table[(125, 'EOF')] = Reduce(63)
        self.action_table[(109, 'r5')] = Shift(83)
        self.action_table[(17, 'val16')] = Shift(63)
        self.action_table[(5, 'align')] = Shift(8)
        self.action_table[(15, 'r2')] = Shift(41)
        self.action_table[(102, 'r0')] = Shift(116)
        self.action_table[(5, 'bne')] = Shift(31)
        self.action_table[(0, 'blt')] = Shift(3)
        self.action_table[(96, 'r3')] = Shift(119)
        self.action_table[(15, 'r7')] = Shift(43)
        self.action_table[(5, 'b')] = Shift(10)
        self.action_table[(18, 'r2')] = Shift(41)
        self.action_table[(80, 'sub')] = Reduce(6)
        self.action_table[(58, ',')] = Shift(99)
        self.action_table[(76, ',')] = Shift(105)
        self.action_table[(134, 'r3')] = Shift(42)
        self.action_table[(167, ']')] = Reduce(21)
        self.action_table[(6, 'EOF')] = Reduce(7)
        self.action_table[(137, ',')] = Reduce(27)
        self.action_table[(67, 'EOF')] = Reduce(15)
        self.action_table[(5, 'ldr')] = Shift(14)
        self.action_table[(160, 'val3')] = Shift(167)
        self.action_table[(118, 'COMMENT')] = Reduce(24)
        self.action_table[(134, 'r4')] = Shift(37)
        self.action_table[(15, 'sp')] = Shift(59)
        self.action_table[(118, 'EOF')] = Reduce(24)
        self.action_table[(98, 'r5')] = Shift(36)
        self.action_table[(101, 'r2')] = Shift(41)
        self.action_table[(5, 'add')] = Shift(15)
        self.action_table[(101, 'r6')] = Shift(35)
        self.action_table[(34, 'r1')] = Shift(90)
        self.action_table[(171, 'COMMENT')] = Reduce(65)
        self.action_table[(9, 'r2')] = Shift(41)
        self.action_table[(66, 'EOF')] = Reduce(16)
        self.action_table[(15, 'r5')] = Shift(36)
        self.action_table[(78, 'COMMENT')] = Reduce(10)
        self.action_table[(14, 'r7')] = Shift(43)
        self.action_table[(80, 'bgt')] = Reduce(6)
        self.action_table[(137, '}')] = Reduce(27)
        self.action_table[(5, 'orr')] = Shift(9)
        self.action_table[(90, '-')] = Reduce(23)
        self.action_table[(57, ',')] = Shift(98)
        self.action_table[(156, 'val3')] = Shift(167)
        self.action_table[(43, ',')] = Reduce(29)
        self.action_table[(38, ',')] = Shift(95)
        self.action_table[(103, 'r4')] = Shift(113)
        self.action_table[(95, 'val8')] = Shift(49)
        self.action_table[(8, 'val8')] = Shift(49)
        self.action_table[(0, 'beq')] = Shift(24)
        self.action_table[(123, ',')] = Shift(146)
        self.action_table[(96, 'r6')] = Shift(111)
        self.action_table[(0, 'lsl')] = Shift(16)
        self.action_table[(87, ',')] = Reduce(58)
        self.action_table[(139, '}')] = Reduce(60)
        self.action_table[(33, 'EOF')] = Reduce(52)
        self.action_table[(130, 'COMMENT')] = Reduce(34)
        self.action_table[(16, 'r5')] = Shift(36)
        self.action_table[(27, 'r4')] = Shift(37)
        self.action_table[(70, 'COMMENT')] = Reduce(50)
        self.action_table[(0, 'add')] = Shift(15)
        self.action_table[(155, 'val5')] = Shift(164)
        self.action_table[(80, 'yield')] = Reduce(6)
        self.action_table[(80, 'COMMENT')] = Reduce(6)
        self.action_table[(133, 'COMMENT')] = Reduce(41)
        self.action_table[(103, 'r7')] = Shift(120)
        self.action_table[(110, 'r1')] = Shift(141)
        self.action_table[(96, 'r7')] = Shift(120)
        self.action_table[(159, 'COMMENT')] = Reduce(35)
        self.action_table[(48, 'EOF')] = Reduce(20)
        self.action_table[(110, 'r5')] = Shift(137)
        self.action_table[(94, '}')] = Reduce(29)
        self.action_table[(80, 'b')] = Reduce(6)
        self.action_table[(0, 'ldr')] = Shift(14)
        self.action_table[(80, 'beq')] = Reduce(6)
        self.action_table[(5, 'cmp')] = Shift(18)
        self.action_table[(80, 'bne')] = Reduce(6)
        self.action_table[(110, 'r4')] = Shift(138)
        self.action_table[(71, ',')] = Shift(104)
        self.action_table[(19, 'ID')] = Shift(70)
        self.action_table[(166, ']')] = Shift(171)
        self.action_table[(2, 'r1')] = Shift(40)
        self.action_table[(90, ',')] = Reduce(23)
        self.action_table[(96, 'r2')] = Shift(118)
        self.action_table[(85, ',')] = Shift(109)
        self.action_table[(2, 'r7')] = Shift(43)
        self.action_table[(27, 'r5')] = Shift(36)
        self.action_table[(98, 'r1')] = Shift(40)
        self.action_table[(50, 'COMMENT')] = Reduce(19)
        self.action_table[(144, '}')] = Reduce(29)
        self.action_table[(21, 'r4')] = Shift(37)
        self.action_table[(14, 'r2')] = Shift(41)
        self.action_table[(174, 'EOF')] = Reduce(61)
        self.action_table[(151, ',')] = Shift(160)
        self.action_table[(64, 'COMMENT')] = Reduce(14)
        self.action_table[(34, 'r6')] = Shift(82)
        self.action_table[(92, '-')] = Reduce(24)
        self.action_table[(29, 'r1')] = Shift(40)
        self.action_table[(128, 'EOF')] = Reduce(40)
        self.action_table[(93, '-')] = Reduce(25)
        self.action_table[(111, 'COMMENT')] = Reduce(28)
        self.action_table[(5, 'lsl')] = Shift(16)
        self.action_table[(15, 'r6')] = Shift(35)
        self.action_table[(109, 'r0')] = Shift(89)
        self.action_table[(15, 'r4')] = Shift(37)
        self.action_table[(32, 'COMMENT')] = Reduce(8)
        self.action_table[(86, '}')] = Reduce(26)
        self.action_table[(34, 'r4')] = Shift(86)
        self.action_table[(31, 'ID')] = Shift(81)
        self.action_table[(12, 'r3')] = Shift(42)
        self.action_table[(103, 'r6')] = Shift(111)
        self.action_table[(134, 'r7')] = Shift(43)
        self.action_table[(0, 'cmp')] = Shift(18)
        self.action_table[(16, 'r0')] = Shift(39)
        self.action_table[(83, '-')] = Reduce(27)
        self.action_table[(120, 'COMMENT')] = Reduce(29)
        self.action_table[(173, 'COMMENT')] = Reduce(64)
        self.action_table[(80, 'blt')] = Reduce(6)
        self.action_table[(21, 'r0')] = Shift(39)
        self.action_table[(150, 'r1')] = Shift(117)
        self.action_table[(80, 'nop')] = Reduce(6)
        self.action_table[(26, 'r1')] = Shift(40)
        self.action_table[(145, 'val5')] = Shift(50)
        self.action_table[(145, 'val3')] = Shift(53)
        self.action_table[(74, 'EOF')] = Reduce(46)
        self.action_table[(34, 'pc')] = Shift(91)
        self.action_table[(96, 'r4')] = Shift(113)
        self.action_table[(21, 'r7')] = Shift(43)
        self.action_table[(122, ',')] = Shift(145)
        self.action_table[(170, ']')] = Shift(174)
        self.action_table[(5, 'COMMENT')] = Reduce(3)
        self.action_table[(109, 'r4')] = Shift(86)
        self.action_table[(104, 'r2')] = Shift(118)
        self.action_table[(105, 'ID')] = Shift(132)
        self.action_table[(115, 'COMMENT')] = Reduce(32)
        self.action_table[(86, ',')] = Reduce(26)
        self.action_table[(81, 'EOF')] = Reduce(47)
        self.action_table[(5, 'EOF')] = Reduce(3)
        self.action_table[(129, 'COMMENT')] = Reduce(33)
        self.action_table[(2, 'r0')] = Shift(39)
        self.action_table[(26, 'r5')] = Shift(36)
        self.action_table[(116, 'COMMENT')] = Reduce(22)
        self.action_table[(32, 'EOF')] = Reduce(8)
        self.action_table[(134, 'r2')] = Shift(41)
        self.action_table[(119, 'COMMENT')] = Reduce(25)
        self.action_table[(0, 'orr')] = Shift(9)
        self.action_table[(169, ']')] = Shift(173)
        self.action_table[(14, 'r1')] = Shift(40)
        self.action_table[(154, 'EOF')] = Reduce(39)
        self.action_table[(14, 'r5')] = Shift(36)
        self.action_table[(12, 'r7')] = Shift(43)
        self.action_table[(159, 'EOF')] = Reduce(35)
        self.action_table[(124, 'r2')] = Shift(41)
        self.action_table[(124, 'r4')] = Shift(37)
        self.action_table[(62, 'COMMENT')] = Reduce(12)
        self.action_table[(89, ',')] = Reduce(22)
        self.action_table[(138, '}')] = Reduce(26)
        self.action_table[(72, 'COMMENT')] = Reduce(45)
        self.action_table[(124, 'r7')] = Shift(43)
        self.action_table[(34, 'r3')] = Shift(93)
        self.action_table[(49, 'COMMENT')] = Reduce(17)
        self.action_table[(29, 'r3')] = Shift(42)
        self.action_table[(134, 'r5')] = Shift(36)
        self.action_table[(51, 'EOF')] = Reduce(18)
        self.action_table[(95, 'r7')] = Shift(120)
        self.action_table[(164, ']')] = Reduce(19)
        self.action_table[(75, 'COMMENT')] = Reduce(51)
        self.action_table[(20, 'EOF')] = Reduce(4)
        self.action_table[(10, 'ID')] = Shift(55)
        self.action_table[(165, ']')] = Reduce(18)
        self.action_table[(173, 'EOF')] = Reduce(64)
        self.action_table[(5, 'beq')] = Shift(24)
        self.action_table[(65, 'EOF')] = Reduce(30)
        self.action_table[(21, 'r5')] = Shift(36)
        self.action_table[(0, 'b')] = Shift(10)
        self.action_table[(80, 'bl')] = Reduce(6)
        self.action_table[(5, 'and')] = Shift(21)
        self.action_table[(9, 'r0')] = Shift(39)
        self.action_table[(0, 'bne')] = Shift(31)
        self.action_table[(16, 'r1')] = Shift(40)
        self.action_table[(68, 'COMMENT')] = Reduce(11)
        self.action_table[(21, 'r2')] = Shift(41)
        self.action_table[(86, '-')] = Reduce(26)
        self.action_table[(18, 'r1')] = Shift(40)
        self.action_table[(82, '-')] = Reduce(28)
        self.action_table[(109, 'pc')] = Shift(91)
        self.action_table[(0, 'align')] = Shift(8)
        self.action_table[(27, 'r3')] = Shift(42)
        self.action_table[(92, ',')] = Reduce(24)
        self.action_table[(95, 'r5')] = Shift(112)
        self.action_table[(17, 'val5')] = Shift(50)
        self.action_table[(44, 'EOF')] = Reduce(48)
        self.action_table[(106, 'r4')] = Shift(113)
        self.action_table[(26, 'r7')] = Shift(43)
        self.action_table[(104, 'r1')] = Shift(117)
        self.action_table[(102, 'r4')] = Shift(113)
        self.action_table[(30, ':')] = Shift(80)
        self.action_table[(46, 'COMMENT')] = Reduce(2)
        self.action_table[(109, 'r1')] = Shift(90)
        self.action_table[(110, 'r3')] = Shift(143)
        self.action_table[(110, 'r2')] = Shift(142)
        self.action_table[(12, 'r5')] = Shift(36)
        self.action_table[(60, ',')] = Shift(101)
        self.action_table[(142, ',')] = Reduce(24)
        self.action_table[(95, 'r6')] = Shift(111)
        self.action_table[(140, '}')] = Reduce(22)
        self.action_table[(135, '}')] = Reduce(56)
        self.action_table[(103, 'val5')] = Shift(50)
        self.action_table[(16, 'r3')] = Shift(42)
        self.action_table[(88, '}')] = Reduce(57)
        self.action_table[(83, '}')] = Reduce(27)
        self.action_table[(109, 'lr')] = Shift(87)
        self.action_table[(54, ',')] = Shift(96)
        self.action_table[(17, 'val12')] = Shift(67)
        self.action_table[(127, ',')] = Shift(150)
        self.action_table[(80, 'add')] = Reduce(6)
        self.action_table[(158, 'EOF')] = Reduce(36)
        self.action_table[(0, 'yield')] = Shift(11)
        self.action_table[(0, 'push')] = Shift(1)
        self.action_table[(104, 'r3')] = Shift(119)
        self.action_table[(20, 'COMMENT')] = Reduce(4)
        self.action_table[(9, 'r7')] = Shift(43)
        self.action_table[(106, 'r0')] = Shift(116)
        self.action_table[(149, 'val3')] = Shift(53)
        self.action_table[(168, ']')] = Shift(172)
        self.action_table[(89, '-')] = Reduce(22)
        self.action_table[(150, 'r0')] = Shift(116)
        self.action_table[(104, 'r4')] = Shift(113)
        self.action_table[(124, 'sp')] = Shift(147)
        self.action_table[(106, 'r1')] = Shift(117)
        self.action_table[(5, 'str')] = Shift(29)
        self.action_table[(141, ',')] = Reduce(23)
        self.action_table[(107, '[')] = Shift(134)
        self.action_table[(108, 'COMMENT')] = Reduce(54)
        self.action_table[(15, 'r3')] = Shift(42)
        self.action_table[(62, 'EOF')] = Reduce(12)
        self.action_table[(72, 'EOF')] = Reduce(45)
        self.action_table[(103, 'val8')] = Shift(49)
        self.action_table[(13, 'EOF')] = Reduce(9)
        self.action_table[(53, 'COMMENT')] = Reduce(21)
        self.action_table[(52, 'EOF')] = Reduce(66)
        self.action_table[(94, ',')] = Reduce(29)
        self.action_table[(0, 'sub')] = Shift(12)
        self.action_table[(70, 'EOF')] = Reduce(50)
        self.action_table[(34, 'lr')] = Shift(87)
        self.action_table[(49, 'EOF')] = Reduce(17)
        self.action_table[(80, 'adr')] = Reduce(6)
        self.action_table[(5, 'lsr')] = Shift(27)
        self.action_table[(140, ',')] = Reduce(22)
        self.action_table[(34, 'r2')] = Shift(92)
        self.action_table[(42, ',')] = Reduce(25)
        self.action_table[(26, 'r3')] = Shift(42)
        self.action_table[(37, ',')] = Reduce(26)
        self.action_table[(150, 'r3')] = Shift(119)
        self.action_table[(141, '}')] = Reduce(23)
        self.action_table[(144, ',')] = Reduce(29)
        self.action_table[(29, 'r0')] = Shift(39)
        self.action_table[(95, 'val3')] = Shift(53)
        self.action_table[(48, 'COMMENT')] = Reduce(20)
        self.action_table[(61, ',')] = Shift(102)
        self.action_table[(64, 'EOF')] = Reduce(14)
        self.action_table[(23, 'ID')] = Shift(73)
        self.action_table[(67, 'COMMENT')] = Reduce(15)
        self.action_table[(150, 'r4')] = Shift(113)
        self.action_table[(89, '}')] = Reduce(22)
        self.action_table[(150, 'r6')] = Shift(111)
        self.action_table[(157, 'EOF')] = Reduce(37)
        self.action_table[(8, 'val5')] = Shift(50)
        self.action_table[(73, 'EOF')] = Reduce(49)
        self.action_table[(25, 'ID')] = Shift(75)
        self.action_table[(15, 'r0')] = Shift(39)
        self.action_table[(102, 'r2')] = Shift(118)
        self.action_table[(103, 'r2')] = Shift(118)
        self.action_table[(46, 'EOF')] = Reduce(2)
        self.action_table[(106, 'r5')] = Shift(112)
        self.action_table[(109, 'r3')] = Shift(93)
        self.action_table[(18, 'r7')] = Shift(43)
        self.action_table[(80, 'dcd')] = Reduce(6)
        self.action_table[(9, 'r5')] = Shift(36)
        self.action_table[(82, ',')] = Reduce(28)
        self.action_table[(40, ',')] = Reduce(23)
        self.action_table[(35, ',')] = Reduce(28)
        self.action_table[(0, 'nop')] = Shift(13)
        self.action_table[(0, 'ID')] = Shift(30)
        self.action_table[(150, 'r5')] = Shift(112)
        self.action_table[(174, 'COMMENT')] = Reduce(61)
        self.action_table[(18, 'r6')] = Shift(35)
        self.action_table[(88, '-')] = Shift(110)
        self.action_table[(80, 'EOF')] = Reduce(6)
        self.action_table[(63, 'COMMENT')] = Reduce(13)
        self.action_table[(106, 'r7')] = Shift(120)
        self.action_table[(148, ',')] = Shift(156)
        self.action_table[(101, 'r7')] = Shift(43)
        self.action_table[(5, 'dcd')] = Shift(17)
        self.action_table[(82, '}')] = Reduce(28)
        self.action_table[(47, 'EOF')] = Reduce(53)
        self.action_table[(106, 'r2')] = Shift(118)
        self.action_table[(5, 'bgt')] = Shift(19)
        self.action_table[(80, 'bge')] = Reduce(6)
        self.action_table[(0, 'EOF')] = Reduce(5)
        self.action_table[(125, 'COMMENT')] = Reduce(63)
        self.action_table[(6, 'COMMENT')] = Reduce(7)
        self.action_table[(106, 'r6')] = Shift(111)
        self.action_table[(153, 'EOF')] = Reduce(38)
        self.action_table[(102, 'r3')] = Shift(119)
        self.action_table[(5, 'section')] = Shift(28)
        self.action_table[(112, 'EOF')] = Reduce(27)
        self.action_table[(5, 'pop')] = Shift(7)
        self.action_table[(154, 'COMMENT')] = Reduce(39)
        self.action_table[(143, '}')] = Reduce(25)
        self.action_table[(2, 'r4')] = Shift(37)
        self.action_table[(80, 'orr')] = Reduce(6)
        self.action_table[(98, 'r3')] = Shift(42)
        self.action_table[(0, 'mov')] = Shift(2)
        self.action_table[(34, 'r0')] = Shift(89)
        self.action_table[(157, 'COMMENT')] = Reduce(37)
        self.action_table[(80, 'lsr')] = Reduce(6)
        self.action_table[(5, 'adr')] = Shift(26)
        self.action_table[(2, 'r3')] = Shift(42)
        self.action_table[(121, 'EOF')] = Reduce(43)
        self.action_table[(104, 'r5')] = Shift(112)
        self.action_table[(161, 'val5')] = Shift(164)
        self.action_table[(131, 'EOF')] = Reduce(42)
        self.action_table[(16, 'r6')] = Shift(35)
        self.action_table[(29, 'r4')] = Shift(37)
        self.action_table[(27, 'r1')] = Shift(40)
        self.action_table[(52, 'COMMENT')] = Reduce(66)
        self.action_table[(124, 'r6')] = Shift(35)
        self.action_table[(17, 'val3')] = Shift(53)
        self.action_table[(5, 'bge')] = Shift(25)
        self.action_table[(24, 'ID')] = Shift(74)
        self.action_table[(134, 'r1')] = Shift(40)
        self.action_table[(163, ']')] = Reduce(17)
        self.action_table[(74, 'COMMENT')] = Reduce(46)
        self.action_table[(80, 'push')] = Reduce(6)
        self.action_table[(104, 'r6')] = Shift(111)
        self.action_table[(109, 'r7')] = Shift(94)
        self.action_table[(41, ',')] = Reduce(24)
        self.action_table[(36, ',')] = Reduce(27)
        self.action_table[(80, 'and')] = Reduce(6)
        self.action_table[(80, 'lsl')] = Reduce(6)
        self.action_table[(101, 'r5')] = Shift(36)
        self.action_table[(5, 'bl')] = Shift(22)
        self.action_table[(114, 'EOF')] = Reduce(31)
        self.action_table[(12, 'r4')] = Shift(37)
        self.action_table[(5, 'nop')] = Shift(13)
        self.action_table[(59, ',')] = Shift(100)
        self.action_table[(98, 'r6')] = Shift(35)
        self.action_table[(110, 'r6')] = Shift(136)
        self.action_table[(5, 'ble')] = Shift(23)
        self.action_table[(78, 'EOF')] = Reduce(10)
        self.action_table[(80, 'align')] = Reduce(6)
        self.action_table[(95, 'r3')] = Shift(119)
        self.action_table[(150, 'val3')] = Shift(53)
        self.action_table[(113, 'COMMENT')] = Reduce(26)
        self.action_table[(132, 'COMMENT')] = Reduce(67)
        self.action_table[(18, 'r5')] = Shift(36)
        self.action_table[(119, 'EOF')] = Reduce(25)
        self.action_table[(26, 'r4')] = Shift(37)
        self.action_table[(129, 'EOF')] = Reduce(33)
        self.action_table[(28, 'ID')] = Shift(78)
        self.action_table[(33, 'COMMENT')] = Reduce(52)
        self.action_table[(133, 'EOF')] = Reduce(41)
        self.action_table[(29, 'r6')] = Shift(35)
        self.action_table[(34, 'r5')] = Shift(83)
        self.action_table[(14, 'r0')] = Shift(39)
        self.action_table[(109, 'r6')] = Shift(82)
        self.action_table[(21, 'r3')] = Shift(42)
        self.action_table[(109, 'r2')] = Shift(92)
        self.action_table[(27, 'r2')] = Shift(41)
        self.action_table[(12, 'r2')] = Shift(41)
        self.action_table[(121, 'COMMENT')] = Reduce(43)
        self.action_table[(51, 'COMMENT')] = Reduce(18)
        self.action_table[(27, 'r7')] = Shift(43)
        self.action_table[(88, ',')] = Reduce(57)
        self.action_table[(138, ',')] = Reduce(26)
        self.action_table[(83, ',')] = Reduce(27)
        self.action_table[(50, 'EOF')] = Reduce(19)
        self.action_table[(69, ',')] = Shift(103)
        self.action_table[(45, 'EOF')] = Accept(1)
        self.action_table[(29, 'r5')] = Shift(36)
        self.action_table[(15, 'r1')] = Shift(40)
        self.action_table[(7, '{')] = Shift(34)
        self.action_table[(93, ',')] = Reduce(25)
        self.action_table[(142, '}')] = Reduce(24)
        self.action_table[(95, 'r2')] = Shift(118)

        self.goto_table = {}
        self.goto_table[(155, 'imm8')] = 166
        self.goto_table[(0, 'instr')] = 20
        self.goto_table[(98, 'reg8')] = 123
        self.goto_table[(160, 'imm8')] = 169
        self.goto_table[(29, 'reg8')] = 79
        self.goto_table[(146, 'imm3')] = 154
        self.goto_table[(160, 'imm3')] = 162
        self.goto_table[(161, 'imm3')] = 162
        self.goto_table[(17, 'imm32')] = 65
        self.goto_table[(17, 'imm8')] = 66
        self.goto_table[(150, 'reg8')] = 159
        self.goto_table[(103, 'reg8')] = 129
        self.goto_table[(18, 'reg8')] = 69
        self.goto_table[(149, 'imm5')] = 51
        self.goto_table[(5, 'instruction')] = 32
        self.goto_table[(34, 'reg8')] = 88
        self.goto_table[(145, 'imm5')] = 51
        self.goto_table[(17, 'imm16')] = 62
        self.goto_table[(17, 'imm5')] = 51
        self.goto_table[(17, 'imm12')] = 64
        self.goto_table[(15, 'reg8')] = 60
        self.goto_table[(155, 'imm5')] = 165
        self.goto_table[(0, 'instruction')] = 32
        self.goto_table[(17, 'imm3')] = 48
        self.goto_table[(2, 'reg8')] = 38
        self.goto_table[(149, 'imm3')] = 48
        self.goto_table[(150, 'imm3')] = 158
        self.goto_table[(103, 'imm3')] = 48
        self.goto_table[(7, 'reg_list')] = 47
        self.goto_table[(106, 'reg8')] = 133
        self.goto_table[(149, 'imm8')] = 157
        self.goto_table[(95, 'imm3')] = 48
        self.goto_table[(160, 'imm5')] = 165
        self.goto_table[(156, 'imm3')] = 162
        self.goto_table[(109, 'reg8')] = 88
        self.goto_table[(8, 'imm5')] = 51
        self.goto_table[(109, 'reg_or_range')] = 85
        self.goto_table[(96, 'reg8')] = 121
        self.goto_table[(21, 'reg8')] = 71
        self.goto_table[(102, 'reg8')] = 128
        self.goto_table[(5, 'pseudoinstruction')] = 6
        self.goto_table[(103, 'imm8')] = 130
        self.goto_table[(156, 'imm5')] = 168
        self.goto_table[(14, 'reg8')] = 58
        self.goto_table[(95, 'reg8')] = 114
        self.goto_table[(161, 'imm5')] = 170
        self.goto_table[(34, 'reg_list_inner')] = 84
        self.goto_table[(27, 'reg8')] = 77
        self.goto_table[(95, 'imm8')] = 115
        self.goto_table[(145, 'imm8')] = 153
        self.goto_table[(0, 'label')] = 5
        self.goto_table[(0, 'asmline2')] = 4
        self.goto_table[(16, 'reg8')] = 61
        self.goto_table[(145, 'imm3')] = 48
        self.goto_table[(8, 'imm8')] = 52
        self.goto_table[(134, 'reg8')] = 152
        self.goto_table[(155, 'imm3')] = 162
        self.goto_table[(34, 'reg_or_range')] = 85
        self.goto_table[(12, 'reg8')] = 57
        self.goto_table[(101, 'reg8')] = 127
        self.goto_table[(110, 'reg8')] = 139
        self.goto_table[(104, 'reg8')] = 131
        self.goto_table[(103, 'imm5')] = 51
        self.goto_table[(0, 'pseudoinstruction')] = 6
        self.goto_table[(5, 'instr')] = 46
        self.goto_table[(109, 'reg_list_inner')] = 135
        self.goto_table[(8, 'imm3')] = 48
        self.goto_table[(9, 'reg8')] = 54
        self.goto_table[(26, 'reg8')] = 76
        self.goto_table[(1, 'reg_list')] = 33
        self.goto_table[(124, 'reg8')] = 148
        self.goto_table[(95, 'imm5')] = 51

    def action_asmline_0(self, arg1):
        pass

    def action_asmline_1(self, arg1, arg2):
        pass

    def action_asmline2_2(self, arg1, arg2):
        pass

    def action_asmline2_3(self, arg1):
        pass

    def action_asmline2_4(self, arg1):
        pass

    def action_asmline2_5(self):
        pass

    def action_label_6(self, arg1, arg2):
        self.assembler.emit(Label(arg1.val))

    def action_instr_7(self, arg1):
        pass

    def action_instr_8(self, arg1):
        self.assembler.emit(arg1)

    def action_pseudoinstruction_9(self, arg1):
        pass

    def action_pseudoinstruction_10(self, arg1, arg2):
        self.assembler.select_section(arg2.val)

    def action_imm32_11(self, arg1):
        return arg1.val

    def action_imm32_12(self, arg1):
        return arg1

    def action_imm16_13(self, arg1):
        return arg1.val

    def action_imm16_14(self, arg1):
        return arg1

    def action_imm12_15(self, arg1):
        return arg1.val

    def action_imm12_16(self, arg1):
        return arg1

    def action_imm8_17(self, arg1):
        return arg1.val

    def action_imm8_18(self, arg1):
        return arg1

    def action_imm5_19(self, arg1):
        return arg1.val

    def action_imm5_20(self, arg1):
        return arg1

    def action_imm3_21(self, arg1):
        return arg1.val

    def action_reg8_22(self, arg1):
        return R0

    def action_reg8_23(self, arg1):
        return R1

    def action_reg8_24(self, arg1):
        return R2

    def action_reg8_25(self, arg1):
        return R3

    def action_reg8_26(self, arg1):
        return R4

    def action_reg8_27(self, arg1):
        return R5

    def action_reg8_28(self, arg1):
        return R6

    def action_reg8_29(self, arg1):
        return R7

    def action_instruction_30(self, arg1, arg2):
        return Dcd(arg2)

    def action_instruction_31(self, arg1, arg2, arg3, arg4):
        return Mov2(arg2, arg4)

    def action_instruction_32(self, arg1, arg2, arg3, arg4):
        return Mov3(arg2, arg4)

    def action_instruction_33(self, arg1, arg2, arg3, arg4):
        return Cmp(arg2, arg4)

    def action_instruction_34(self, arg1, arg2, arg3, arg4):
        return Cmp2(arg2, arg4)

    def action_instruction_35(self, arg1, arg2, arg3, arg4, arg5, arg6):
        return Add3(arg2, arg4, arg6)

    def action_instruction_36(self, arg1, arg2, arg3, arg4, arg5, arg6):
        return Add2(arg2, arg4, arg6)

    def action_instruction_37(self, arg1, arg2, arg3, arg4, arg5, arg6):
        return Add(SP, SP, arg6)

    def action_instruction_38(self, arg1, arg2, arg3, arg4, arg5, arg6):
        return Sub(SP, SP, arg6)

    def action_instruction_39(self, arg1, arg2, arg3, arg4, arg5, arg6):
        return Sub(arg2, arg4, arg6)

    def action_instruction_40(self, arg1, arg2, arg3, arg4):
        return Lsl(arg2, arg4)

    def action_instruction_41(self, arg1, arg2, arg3, arg4):
        return Lsr(arg2, arg4)

    def action_instruction_42(self, arg1, arg2, arg3, arg4):
        return And(arg2, arg4)

    def action_instruction_43(self, arg1, arg2, arg3, arg4):
        return Orr(arg2, arg4)

    def action_instruction_44(self, arg1, arg2):
        return B(arg2.val)

    def action_instruction_45(self, arg1, arg2):
        return Bl(arg2.val)

    def action_instruction_46(self, arg1, arg2):
        return Beq(arg2.val)

    def action_instruction_47(self, arg1, arg2):
        return Bne(arg2.val)

    def action_instruction_48(self, arg1, arg2):
        return Blt(arg2.val)

    def action_instruction_49(self, arg1, arg2):
        return Ble(arg2.val)

    def action_instruction_50(self, arg1, arg2):
        return Bgt(arg2.val)

    def action_instruction_51(self, arg1, arg2):
        return Bge(arg2.val)

    def action_instruction_52(self, arg1, arg2):
        return Push(arg2)

    def action_instruction_53(self, arg1, arg2):
        return Pop(arg2)

    def action_reg_list_54(self, arg1, arg2, arg3):
        return arg2

    def action_reg_list_inner_55(self, arg1):
        return arg1

    def action_reg_list_inner_56(self, arg1, arg2, arg3):
        return arg1 | arg3

    def action_reg_or_range_57(self, arg1):
        return set([arg1])

    def action_reg_or_range_58(self, arg1):
        return set([LR])

    def action_reg_or_range_59(self, arg1):
        return set([PC])

    def action_reg_or_range_60(self, arg1, arg2, arg3):
        return register_range(arg1, arg3)

    def action_instruction_61(self, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8):
        return Str2(arg2, arg5, arg7)

    def action_instruction_62(self, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8):
        return Ldr2(arg2, arg5, arg7)

    def action_instruction_63(self, arg1, arg2, arg3, arg4):
        return Ldr(arg2, arg4.val)

    def action_instruction_64(self, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8):
        return Str1(arg2, arg7)

    def action_instruction_65(self, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8):
        return Ldr1(arg2, arg7)

    def action_instruction_66(self, arg1, arg2):
        return Alignment(arg2)

    def action_instruction_67(self, arg1, arg2, arg3, arg4):
        return Adr(arg2, arg4.val)

    def action_instruction_68(self, arg1):
        return Yield()

